#ifndef _HUNTER_H
#define _HUNTER_H

#include "AllegroBitmapGame.h"
#include "Curl.h"
#include "partypack/resourcemanager.h"
#include "MusicPlayer.h"
#include "GameState.h"

class LevelSet;
class Menu;
class MainGame;

class Hunter : public AllegroBitmapGame {
	public:
		Hunter();
		virtual ~Hunter();

		virtual int getScreenX() { return 640; }
		virtual int getScreenY() { return 480; }
		virtual int getScreenBPP() { return 16; }

		virtual void setupGame();
		virtual void updateGameLogic();
		virtual void drawScreen(alBitmap &buffer);

		virtual char *getTitle() { return "Troll Hunter"; }
	public:

		Curl curl;
		ResourceManager rm;
		MusicPlayer *mp;
		LevelSet *levels;

		DATAFILE *datafile;
		FONT *v8, *v9, *v10, *v10b, *v10i, *v10bi, *futura, *futura16;

		GameState *game;

		Menu *menu;
		MainGame *maingame;

		class Title : public GameState {
			public:
				Title();
				~Title() {}
				void draw(alBitmap &bitmap) { bitmap.draw(title,0,0); }
				void update();
			private:
				BITMAP *title;
		};
		Title *title;

};

#endif
