#ifndef _LEVEL_H
#define _LEVEL_H

#include <string>
#include <vector>
#include "alBitmap.h"

using namespace std;

class Level {
	public:
		Level(string url, string title, int level);
		~Level();

		void parse();

		int calcHeight(int width);
		void draw(alBitmap &bitmap);
		string getTitle() { return title; }
		int getLevel() { return level; }
		bool getUnlocked() { return unlocked; }

	private:
		string url, title, forum;
		bool parsed;
		bool unlocked;
		int level;

		struct Post {
			string author, number, joindate, avatar, postedon;
			bool hasAvatar;
			vector<string> body;
			Post() : hasAvatar(false) {}

			int calcHeight();
			int draw(int y, alBitmap *bitmap);
		};

		vector<Post*> posts;

};

#endif
